.MODEL SMALL
.486
STACK    SEGMENT  STACK
  DB 128 DUP(?)
STACK    ENDS
DATA       SEGMENT
I8255A     EQU     210H
I8255B     EQU     211H
I8255C     EQU     212H
I8255K     EQU     213H
IOAD_S	EQU	220H
HZ_TAB     DW 0A3C1H,0A3CCH,0A3C1H ,0A3D2H,0A3CDH,0A3ADH,0A3ADH,0A3ADH ;ALARM
           DW 0A3ADH, 0A3C8H,0A3C9H,0A3C7H,0A3C8H,0A3ADH,0A3ADH,0A3ADH ;-HIGH---. 
         ; DW 0A3ADH,0A3C4H,0A3D5H,0A3D4H,0A3ADH,0A2B4H,0A2B8H,0A2B6H ;---DUT-4.8.6.      
         ; DW 0A3ADH, 0A3C8H,0A3C9H,0A3C7H,0A3C8H,0A3ADH,0A3ADH,0A3ADH ;-HIGH---. 
         
          ;0A3C1H   A     ;;   0A3C8H   H     ;;0A3C9H   I     ;; 0A3C7H   G  ;;0A3C8H   H  
          ;0A3C1H   A     ;;   0A3C12H   L    ;;0A3C1H   A  ;; 0A3C18H   R     ;; 0A3C13H   M   ;;

           
 
HZ_ADR          DB  ?           ;存放显示行起始端口地址
DATA       ENDS

CODE       SEGMENT
           ASSUME  CS:CODE,DS:DATA,SS:STACK


START:

;lcd显示模块，显示系统功能以及报警提示信息！！！
LCD:
           
           MOV     AX,DATA             ;设数据据寄存器的值
           MOV     DS,AX               
           MOV     DX,I8255K           ;设8255方式0，A输出B口输出
           MOV     AL,80H
           OUT     DX,AL               ;写入8255控制寄存器
           CALL    CLEAR               ;LCD 清除
           LEA     BX,HZ_TAB
           MOV     CH,2                ;显示第2行信息 
           CALL    LCD_DISP
;最重要的部分，这里LCD显示第二行结束一定要跳转到ADC转换模块！！！
            JMP  ADCC       
LL:        JMP     LL  

;清屏模块
CLEAR      PROC
           MOV     AL,0CH
           MOV     DX,I8255A
           OUT     DX,AL               ;设置CLEAR命令
           CALL    CMD_SETUP           ;启动LCD执行命令
           RET
CLEAR      ENDP

FUNCUP     PROC
           MOV     AL,34H              ;LCD显示状态命令
           OUT     DX,AL
           CALL    CMD_SETUP
           RET
FUNCUP     ENDP
;LCD显示
LCD_DISP   PROC
           LEA     BX,HZ_TAB
           CMP     CH,2
           JZ      DISP_SEC
           MOV     BYTE PTR HZ_ADR, 88H ;第三行起始端口地址
           ADD     BX,16                ;指向第二行信息
           JMP     NEXT 
DISP_SEC:  MOV     BYTE PTR HZ_ADR,90H
NEXT:      MOV     CL,8 
CONTINUE:  PUSH    CX   
           MOV     AL,HZ_ADR
           MOV     DX,I8255A
           OUT     DX,AL
           CALL    CMD_SETUP           ;设定DDRAM地址命令
           MOV     AX,[BX]
           PUSH    AX
           MOV     AL,AH               ;先送编码高位
           MOV     DX,I8255A
           OUT     DX,AL
           CALL    DATA_SETUP          ;输出编码高字节
           CALL    DELAY               ;延迟
           POP     AX
           MOV     DX,I8255A
           OUT     DX,AL
           CALL    DATA_SETUP          ;输出编码低字节
           CALL    DELAY
           INC     BX
           INC     BX                  ;修改显示内码缓冲区指针
           INC     BYTE PTR HZ_ADR     ;修改LCD显示端口地址
           POP     CX
           DEC     CL
           JNZ     CONTINUE
           RET
LCD_DISP   ENDP
CMD_SETUP  PROC
           MOV     DX,I8255C           ;指向8255端口控制端口
           MOV     AL,00000000B        ;PC1置0,PC0置0 （LCD I端=0，W端＝0）
           OUT     DX,AL
           NOP
           CALL    DELAY    
           NOP
           MOV     AL,00000100B        ;PC2置1 （LCD E端＝1）
           OUT     DX,AL
           NOP
           CALL    DELAY 
           MOV     AL,00000000B        ;PC2置0,（LCD E端置0）
           OUT     DX,AL
           CALL    DELAY 
           RET
CMD_SETUP  ENDP
DATA_SETUP PROC
           MOV     DX,I8255C           ;指向8255控制端口
           MOV     AL,00000001B        ;PC1置0，PC0=1 （LCD I端=1）
           OUT     DX,AL
           NOP
           CALL    DELAY 
           MOV     AL,00000101B        ;PC2置1 （LCD E端＝1）
           OUT     DX,AL
           NOP
           CALL    DELAY
           MOV     AL,00000001B       ;PC2置0,（LCD E端＝0）
           OUT     DX,AL
           NOP
           CALL    DELAY
           
           
DATA_SETUP ENDP

;延时函数
DELAY      PROC
           PUSH    CX   
           PUSH    DX      
           MOV     CX,0FFFH
X1:        LOOP    X1      
           POP     DX
           POP     CX
           RET
DELAY      ENDP
           RET


;ADC转换模块，采集滑动变阻器电压
 ADCC: 
MOV	AX,DATA
	MOV	DS,AX
	
	MOV	DX,I8255K
	MOV	AL,10000000B;PA口方式0输出
	OUT	DX,AL
LOP1:	MOV	DX,IOAD_S
	OUT	DX,AL;启动转换
	MOV	DX,IOAD_S+2
LOP2:	IN	AL,DX;获取状态端口信息
	TEST	AL,01H;判断最低位是不是1
	JZ	LOP2;不是1的话继续获取
	MOV	DX,IOAD_S+1;获取数据端口信息
IN	AL,DX;转换结果存到AL

;进入判断
;首先判断是否大于上限
CMP AL,60H
JNA NEXTY;小于等于上限
MOV AL,01H;大于10H红灯亮
;LCD显示报警信息
CALL    CLEAR               ;LCD 清除
         LEA     BX,HZ_TAB
         MOV     CH,3                ;显示第3行信息:HIGH
         CALL    LCD_DISP
JMP SHUCHU


;电压过低
NEXTY:
CMP AL,02H
JNB NEXT1;大于等于下限
MOV AL,02H;低于下限04H黄灯亮
JMP SHUCHU

;安全区
NEXT1:
MOV AL,04H;在区间内绿灯亮

SHUCHU:
MOV	DX,I8255B
OUT DX,AL;结果送给8255A的PA口输出
CALL	DELAYY;软件延时法，使延时时间大于转换时间
JMP	LOP1;不停转换
 
 
DELAYY:PUSH	BX;压入堆栈，保护现场
PUSH	CX
MOV	BX,10H
DE2:	MOV	CX,800
DE1:LOOP	DE1;循环将BX-1
DEC	BX
JNZ	DE2;不为0就使CX=800
POP	CX
POP	BX
RET

CODE       ENDS
           END     START